Package icyllis.modernui.util

# Class SparseArray<E>

java.lang.Object
icyllis.modernui.util.SparseArray<E>

All Implemented Interfaces:
  `Cloneable`

public class SparseArray<E> extends Object implements Cloneable
`SparseArray` maps integers to Objects and, unlike a normal array of Objects, its indices can contain gaps. `SparseArray` is intended to be more memory-efficient than a `HashMap`, because it avoids auto-boxing keys and its data structure doesn't rely on an extra entry object for each mapping.

Note that this container keeps its mappings in an array data structure, using a binary search to find keys. The implementation is not intended to be appropriate for data structures that may contain large numbers of items. It is generally slower than a `HashMap` because lookups require a binary search, and adds and removes require inserting and deleting entries in the array. For containers holding up to hundreds of items, the performance difference is less than 50%.

To help with performance, the container includes an optimization when removing keys: instead of compacting its array immediately, it leaves the removed entry marked as deleted. The entry can then be re-used for the same key or compacted later in a single garbage collection of all removed entries. This garbage collection must be performed whenever the array needs to be grown, or when the map size or entry values are retrieved.

It is possible to iterate over the items in this container using `keyAt(int)` and `valueAt(int)`. Iterating over the keys using `keyAt(int)` with ascending values of the index returns the keys in ascending order. In the case of `valueAt(int)`, the values corresponding to the keys are returned in ascending order.

Modified from Android.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SparseArray()`
  Creates a new SparseArray containing no mappings.
  `SparseArray(int initialCapacity)`
  Creates a new SparseArray containing no mappings that will not require any additional memory allocation to store the specified number of mappings.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `append(int key, E value)`
  Puts a key/value pair into the array, optimizing for the case where the key is greater than all existing keys in the array.
  `void`
  `clear()`
  Removes all key-value mappings from this SparseArray.
  `SparseArray<E>`
  `clone()`
  `boolean`
  `containsKey(int key)`
  Returns true if the key exists in the array.
  `boolean`
  `containsValue(E value)`
  Returns true if the specified value is mapped from any key.
  `void`
  `delete(int key)`
  Removes the mapping from the specified key, if there was any.
  `void`
  `deleteAt(int index)`
  Removes the mapping at the specified index, if there was any.
  `boolean`
  `equals(Object o)`
  `E`
  `get(int key)`
  Gets the Object mapped from the specified key, or `null` if no such mapping has been made.
  `E`
  `get(int key, E defaultValue)`
  Gets the Object mapped from the specified key, or the specified Object if no such mapping has been made.
  `int`
  `hashCode()`
  `int`
  `indexOfKey(int key)`
  Returns the index for which `keyAt(int)` would return the specified key, or a negative number if the specified key is not mapped.
  `int`
  `indexOfValue(E value)`
  Returns an index for which `valueAt(int)` would return the specified value, or a negative number if no keys map to the specified value.
  `int`
  `indexOfValueByValue(E value)`
  Returns an index for which `valueAt(int)` would return the specified value, or a negative number if no keys map to the specified value.
  `boolean`
  `isEmpty()`
  Return true if size() is 0.
  `int`
  `keyAt(int index)`
  Given an index in the range `0...size()-1`, returns the key from the `index`th key-value mapping that this SparseArray stores.
  `E`
  `put(int key, E value)`
  Adds a mapping from the specified key to the specified value, replacing the previous mapping from the specified key if there was one.
  `void`
  `putAll(SparseArray<? extends E> other)`
  Copies all the mappings from the `other` to this map.
  `E`
  `putIfAbsent(int key, E value)`
  Add a new value to the array map only if the key does not already have a value or it is mapped to `null`.
  `E`
  `remove(int key)`
  Removes the mapping from the specified key, if there was any, returning the old value.
  `boolean`
  `remove(int key, Object value)`
  Remove an existing key from the array map only if it is currently mapped to `value`.
  `E`
  `removeAt(int index)`
  Removes the mapping at the specified index, if there was any, returning the old value.
  `void`
  `removeAtRange(int index, int size)`
  Remove a range of mappings as a batch.
  `E`
  `replace(int key, E value)`
  Replace the mapping for `key` only if it is already mapped to a value.
  `boolean`
  `replace(int key, E oldValue, E newValue)`
  Replace the mapping for `key` only if it is already mapped to a value.
  `void`
  `setValueAt(int index, E value)`
  Given an index in the range `0...size()-1`, sets a new value for the `index`th key-value mapping that this SparseArray stores.
  `int`
  `size()`
  Returns the number of key-value mappings that this SparseArray currently stores.
  `String`
  `toString()`
  `E`
  `valueAt(int index)`
  Given an index in the range `0...size()-1`, returns the value from the `index`th key-value mapping that this SparseArray stores.

  ### Methods inherited from class java.lang.Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### SparseArray

    public SparseArray()
    Creates a new SparseArray containing no mappings.

  - ### SparseArray

    public SparseArray(int initialCapacity)
    Creates a new SparseArray containing no mappings that will not require any additional memory allocation to store the specified number of mappings. If you supply an initial capacity of 0, the sparse array will be initialized with a light-weight representation not requiring any additional array allocations.

- ## Method Details

  - ### get

    public E get(int key)
    Gets the Object mapped from the specified key, or `null` if no such mapping has been made.

  - ### get

    public E get(int key, E defaultValue)
    Gets the Object mapped from the specified key, or the specified Object if no such mapping has been made.

  - ### delete

    public void delete(int key)
    Removes the mapping from the specified key, if there was any.

  - ### remove

    public E remove(int key)
    Removes the mapping from the specified key, if there was any, returning the old value.

  - ### remove

    public boolean remove(int key, Object value)
    Remove an existing key from the array map only if it is currently mapped to `value`.
    Parameters:
      `key` - The key of the mapping to remove.
      `value` - The value expected to be mapped to the key.
    Returns:
      Returns true if the mapping was removed.

  - ### deleteAt

    public void deleteAt(int index)
    Removes the mapping at the specified index, if there was any.
    Throws:
      `IndexOutOfBoundsException` - if the index is out of range (`index < 0 || index >= size()`)

  - ### removeAt

    public E removeAt(int index)
    Removes the mapping at the specified index, if there was any, returning the old value.
    Throws:
      `IndexOutOfBoundsException` - if the index is out of range (`index < 0 || index >= size()`)

  - ### removeAtRange

    public void removeAtRange(int index, int size)
    Remove a range of mappings as a batch.
    Parameters:
      `index` - Index to begin at
      `size` - Number of mappings to remove

  - ### replace

    @Nullable public E replace(int key, E value)
    Replace the mapping for `key` only if it is already mapped to a value.
    Parameters:
      `key` - The key of the mapping to replace.
      `value` - The value to store for the given key.
    Returns:
      Returns the previous mapped value or null.

  - ### replace

    public boolean replace(int key, E oldValue, E newValue)
    Replace the mapping for `key` only if it is already mapped to a value.
    Parameters:
      `key` - The key of the mapping to replace.
      `oldValue` - The value expected to be mapped to the key.
      `newValue` - The value to store for the given key.
    Returns:
      Returns true if the value was replaced.

  - ### put

    @Nullable public E put(int key, E value)
    Adds a mapping from the specified key to the specified value, replacing the previous mapping from the specified key if there was one.
    Returns:
      Returns the previous mapped value or null.

  - ### putAll

    public void putAll(@Nonnull SparseArray<? extends E> other)
    Copies all the mappings from the `other` to this map. The effect of this call is equivalent to that of calling `put(int, Object)` on this map once for each mapping from key to value in `other`.

  - ### putIfAbsent

    @Nullable public E putIfAbsent(int key, E value)
    Add a new value to the array map only if the key does not already have a value or it is mapped to `null`.
    Parameters:
      `key` - The key under which to store the value.
      `value` - The value to store for the given key.
    Returns:
      Returns the value that was stored for the given key, or null if there was no such key.

  - ### size

    public int size()
    Returns the number of key-value mappings that this SparseArray currently stores.

  - ### isEmpty

    public boolean isEmpty()
    Return true if size() is 0.
    Returns:
      true if size() is 0.

  - ### keyAt

    public int keyAt(int index)
    Given an index in the range `0...size()-1`, returns the key from the `index`th key-value mapping that this SparseArray stores.

    The keys corresponding to indices in ascending order are guaranteed to be in ascending order, e.g., `keyAt(0)` will return the smallest key and `keyAt(size()-1)` will return the largest key.

    Throws:
      `IndexOutOfBoundsException` - if the index is out of range (`index < 0 || index >= size()`)

  - ### valueAt

    public E valueAt(int index)
    Given an index in the range `0...size()-1`, returns the value from the `index`th key-value mapping that this SparseArray stores.

    The values corresponding to indices in ascending order are guaranteed to be associated with keys in ascending order, e.g., `valueAt(0)` will return the value associated with the smallest key and `valueAt(size()-1)` will return the value associated with the largest key.

    Throws:
      `IndexOutOfBoundsException` - if the index is out of range (`index < 0 || index >= size()`)

  - ### setValueAt

    public void setValueAt(int index, E value)
    Given an index in the range `0...size()-1`, sets a new value for the `index`th key-value mapping that this SparseArray stores.
    Throws:
      `IndexOutOfBoundsException` - if the index is out of range (`index < 0 || index >= size()`)

  - ### indexOfKey

    public int indexOfKey(int key)
    Returns the index for which `keyAt(int)` would return the specified key, or a negative number if the specified key is not mapped.

  - ### indexOfValue

    public int indexOfValue(E value)
    Returns an index for which `valueAt(int)` would return the specified value, or a negative number if no keys map to the specified value.

    Beware that this is a linear search, unlike lookups by key, and that multiple keys can map to the same value and this will find only one of them.

    Note also that unlike most collections' `indexOf` methods, this method compares values using `==` rather than `equals`.

  - ### indexOfValueByValue

    public int indexOfValueByValue(E value)
    Returns an index for which `valueAt(int)` would return the specified value, or a negative number if no keys map to the specified value.

    Beware that this is a linear search, unlike lookups by key, and that multiple keys can map to the same value and this will find only one of them.

    Note also that this method uses `equals` unlike `indexOfValue`.

  - ### containsKey

    public boolean containsKey(int key)
    Returns true if the key exists in the array. This is equivalent to `indexOfKey(int)` >= 0.
    Parameters:
      `key` - Potential key in the mapping
    Returns:
      true if the key is defined in the mapping

  - ### containsValue

    public boolean containsValue(E value)
    Returns true if the specified value is mapped from any key.

  - ### clear

    public void clear()
    Removes all key-value mappings from this SparseArray.

  - ### append

    public void append(int key, E value)
    Puts a key/value pair into the array, optimizing for the case where the key is greater than all existing keys in the array.

  - ### toString

    public String toString()

    This implementation composes a string by iterating over its mappings. If this map contains itself as a value, the string "(this Map)" will appear in its place.

    Overrides:
      `toString` in class `Object`

  - ### equals

    public boolean equals(Object o)
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### clone

    public SparseArray<E> clone()
    Overrides:
      `clone` in class `Object`